Codeforces Round #134 (Div. 1) A. Ice Skating

题目

A. Ice Skating


Bajtek is learning to skate on ice. He's a beginner, so his only mode of transportation is pushing off from a snow drift to the north, east, south or west and sliding until he lands in another snow drift. He has noticed that in this way it's impossible to get from some snow drifts to some other by any sequence of moves. He now wants to heap up some additional snow drifts, so that he can get from any snow drift to any other one. He asked you to find the minimal number of snow drifts that need to be created.

We assume that Bajtek can only heap up snow drifts at integer coordinates.


Input

The first line of input contains a single integer n (1 ≤ n ≤ 100) — the number of snow drifts. Each of the following n lines contains two integers xi and yi (1 ≤ xi, yi ≤ 1000) — the coordinates of the i-th snow drift.

Note that the north direction coinсides with the direction of Oy axis, so the east direction coinсides with the direction of the Ox axis. All snow drift's locations are distinct.


Output

Output the minimal number of snow drifts that need to be created in order for Bajtek to be able to reach any snow drift from any other one.


Examples

Input

2
2 1
1 2

Output

1

Input

2
2 1
4 1

Output

0

思路

  • 使用并查集, 如果两个点的横坐标或纵坐标相同就加入到一个集合中
  • 因为只能水平或竖直滑雪
  • 最后统计连通块数
  • 最终目的是使连通块数为1
  • 连接两个连通块需要一个额外雪堆
  • 连通块数-1就是要额外增加的雪堆

代码

#include<iostream>
#include<cstring>
using namespace std;
#define _for(i,a,b) for(int i=(a);i<(b);i++)
#define _rep(i,a,b) for(int i=(a);i<=(b);i++)
typedef pair<int, int> PLL;
typedef long long ll;
const int N = 2e5+5;
const int INF = 0x3f3f3f3f;
int readint(){
    int x;scanf("%d",&x);return x;
}
int n;
struct Node {
    int x, y;
}a[101];
int fa[101];
int find(int x) {
    if(fa[x] != x) return fa[x] = find(fa[x]);
    return x;
}
int main()
{
    n = readint();
    _rep(i, 1, n) {
        a[i].x = readint(), a[i].y = readint();
        fa[i] = i;
    }
    _rep(i, 1, n) {
        _rep(j, 1, n) {
            if(a[i].x == a[j].x || a[i].y == a[j].y) {
                int fi = find(i), fj = find(j);
                if(fi != fj) {
                    fa[fi] = fj;
                } 
            }
        }
    }
    int cnt = 0;
    _rep(i, 1, n) 
        if(fa[i] == i) cnt++;
    printf("%d\n", cnt - 1);
    return 0;
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值